/***************************************************************************
 *   Copyright (C) 2004 by Sylvain Joyeux                                  *
 *   sylvain.joyeux@m4x.org                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef UTILS_H
#define UTILS_H

template<class T>
static QString sizeToString(T size)
{
  static const QString prefixes[] =
    { "", "k", "M", "G", QString::null };

  const QString* prefix;
  unsigned int value = 1;
  for (prefix = prefixes; !(prefix -> isNull()); ++prefix)
  {
    if (value * 1000 >= (unsigned int) size) break;
    value *= 1024;
  }
  // well, it's assuming that nothing is > 1 TB ...
  ASSERT(!prefix -> isNull());

  return QString::number(((double)size)/value, 'g', 3) + " " + *prefix + "B";

}

#endif
