/***************************************************************************
 *   Copyright (C) 2004 by Sylvain Joyeux                                  *
 *   sylvain.joyeux@m4x.org                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GETDAEMON_H
#define GETDAEMON_H

#include "getiface.h"

#include <libkdeapt/get.h>

/**
@author Sylvain Joyeux
*/
class GetDaemon : public APT::Get, public GetIface
{
public:
  GetDaemon();
  ~GetDaemon();

  virtual bool install(QStringList query);
  virtual bool update();
  virtual bool upgrade(bool distupgrade);

  virtual void quit();

  virtual void setQueryAnswer(QVariant answer);
  virtual bool needsAnswer();

  virtual void cancelCurTask(bool wait);

protected:
  virtual void beginTask(APT::BeginTask* task);
  virtual void endTask(APT::EndTask* task);

  virtual void beginStage(APT::BeginStage* event);

  virtual void newItem(APT::NewItem* event);
  virtual void setItemState(APT::SetItemState* event);
  virtual void itemProgression(APT::ItemProgression* event);

  virtual void questionYN(APT::Prompt* event);
  virtual void questionText(APT::Prompt* event);

  virtual void conffile(APT::Conffile* event);

  virtual void stats(APT::Stats* event);

  virtual void overallProgression(APT::OverallProgression* event);

  virtual void error(APT::Notify* event);
  virtual void warning(APT::Notify* event);
  virtual void info(APT::Notify* event);

  virtual void subwin(APT::SubwinId* event);
};

#endif
