/***************************************************************************
 *   Copyright (C) 2004 by Sylvain Joyeux                                  *
 *   sylvain.joyeux@m4x.org                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GETIFACE_H
#define GETIFACE_H

#include <dcopobject.h>
#include <libkdeapt/progress.h>

class GetIface : virtual public DCOPObject
{
  K_DCOP

k_dcop:
  virtual bool install(QStringList query) = 0;
  virtual bool update() = 0;
  virtual bool upgrade(bool distupgrade) = 0;

  virtual void setQueryAnswer(QVariant answer) = 0;

  virtual bool needsAnswer() = 0;

  /* There's no way to make KUniqueApplication (TODO:
   * send a bugreport) use KAppDCOPInterface. Since I don't
   * want to register one object only to get a quit(), I
   * add it here */
  virtual void quit() = 0;

  virtual void cancelCurTask(bool wait) = 0;

k_dcop_signals:
  void beginTask();
  void endTask();

  void beginStage(int category, QString newstage);

  void newItem(QString key, QString desc, QString dlinfo, int size);
  void setItemState(QString key, int state);
  void itemProgression(QString key, int current, int total);

  void questionYN(QString message);
  void questionText(QString message);

  void conffile(QString file);

  void stats(APT::Stats stats);

  void overallProgression(int curItem, int totalItems,
    double curBytes, double totalBytes, double cps);

  void error(QString key, QString message);
  void warning(QString key, QString message);
  void info(QString key, QString message);

  void subwin(int id);
};

#endif
