/***************************************************************************
 *   Copyright (C) 2004 by Sylvain Joyeux                                  *
 *   sylvain.joyeux@m4x.org                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kpkgmanagerd.h"

#include "getdaemon.h"

#include <kuniqueapplication.h>
#include <dcopclient.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

/************************************************************
 * Init part
 */
static const char description[] =
    I18N_NOOP("A DCOP daemon for executing package management tasks");

static const char version[] = "0.1";

static KCmdLineOptions options[] =
{
//    { "+[URL]", I18N_NOOP( "Document to open." ), 0 },
    KCmdLineLastOption
};

int main(int argc, char **argv)
{
  KAboutData about("kpkgmanagerd", I18N_NOOP("KDE Package manager daemon"), version, description,
                    KAboutData::License_GPL, "(C) 2004 Sylvain Joyeux", 0, 0, "sylvain.joyeux@m4x.org");
  about.addAuthor( "Sylvain Joyeux", 0, "sylvain.joyeux@m4x.org" );
  KCmdLineArgs::init(argc, argv, &about);
  KCmdLineArgs::addCmdLineOptions( options );
  KUniqueApplication::addCmdLineOptions();

  if (!KUniqueApplication::start()) {
      fprintf(stderr, "KPkgManagerd is already running!\n");
      return 0;
  }

  KUniqueApplication a(false, false);

  DCOPClient* dcop = a.dcopClient();
  dcop -> setAcceptCalls(true);
  dcop -> setDaemonMode(true);

  GetDaemon* get = new GetDaemon;
  a.exec();
  delete get;
}
