/***************************************************************************
 *   Copyright (C) 2004 by Sylvain Joyeux                                  *
 *   sylvain.joyeux@m4x.org                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "packagesystem.h"

#include "packagemanager.h"

#include <apt-pkg/debversion.h>
#include <apt-pkg/configuration.h>

#include <qregexp.h>
#include <qdir.h>
#include <kdebug.h>

namespace APT {

PackageSystem::PackageSystem()
{
  Label = "KDE-APT";
  kdDebug() << "PackageSystem initialized" << endl;
}

PackageSystem::~PackageSystem() {}

pkgPackageManager *PackageSystem::CreatePM(pkgDepCache *Cache) const
{
  return new PackageManager(Cache);
}

signed PackageSystem::Score(Configuration const &Cnf)
{
  kdDebug() << "score called" << endl;
  int real_score = debSystem::Score(Cnf);
  return real_score ? real_score + 1 : 0;
}

bool PackageSystem::checkUpdates( )
{
	static const QRegExp rx_notdigit ("[^0-9]");
	QString path = (flNotFile(_config->Find("Dir::State::status")) + "updates/").c_str();
  QDir dir(path);
  if (!dir.exists()) return false;

  QStringList files = dir.entryList();
  for (QStringList::ConstIterator f = files.begin(); f != files.end(); ++f)
  {
  	if (rx_notdigit.search(*f) == -1)
    	return true;
  }
  return false;
}

};

