/***************************************************************************
 *   This code is from the Apt command line tools
 *   Apt is copyright 1997, 1998, 1999 Jason Gunthorpe and others.
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CACHEFILE_H
#define CACHEFILE_H

#include <apt-pkg/cachefile.h>
#include <apt-pkg/init.h>

namespace APT
{
  class Task;

// class CacheFile - Cover class for some dependency cache functions	/*{{{*/
// ---------------------------------------------------------------------
/* */
class CacheFile : public pkgCacheFile
{
  static pkgCache *SortCache;
  static int NameComp(const void *a,const void *b);

  Task* m_parent;

public:
  pkgCache::Package **List;

  CacheFile(Task* parent);

  void Sort();
  bool CheckDeps(bool AllowBroken = false);
  bool BuildCaches(bool WithLock = true);
  bool Open(bool WithLock = true);
  bool OpenForInstall();
};
};

#endif
